Request

Response

    Issues
    GET

    containers/{containerId}/issues

    Retrieves information about all the issues in a project, including count of the associated comments and attachments.

    Note that this endpoint is ONLY compatible with BIM 360 projects. It is not compatible with Autodesk Construction Cloud (ACC) projects. For more information about compatibility between between BIM 360 and ACC, see the Compatibility section.

    Resource Information

    Method and URI
    GET
    https://developer.api.autodesk.com/issues/v2/containers/:containerId/issues
    Authentication Context
    user context required
    Required OAuth Scopes
    data:read
    Data Format
    JSON

    Request

    Headers

    Authorization*
    string
    Must be Bearer <token>, where <token> is obtained via a three-legged OAuth flow.
    * Required

    Request

    URI Parameters

    containerId
    string
    The ID of the container.

    Each project is assigned to a container that stores all the issues for the project.

    Use the Data Management API to retrieve the container ID. For more information, see the Retrieve Issues Container ID tutorial.

    Request

    Query String Parameters

    filter[id]
    string
    Filter issues by the unique issue ID. Separate multiple values with commas
    filter[qualityUrns]
    string
    Filter issues by quality URNs (for example checklist). Separate multiple values with commas.
    filter[issueTypeId]
    string
    Filter issues by the unique identifier of the type of the issue. Separate multiple values with commas
    filter[issueSubtypeId]
    string
    Filter issues by the unique identifier of the subtype of the issue. Separate multiple values with commas
    filter[status]
    string
    Filter issues by the unique identifier of the current status of the issue. Separate multiple values with commas
    filter[linkedDocumentUrn]
    array: string
    Filter issues by linked file/document URN’s. Separate multiple values with commas. To filter by maximum version, add “@[version-number]” after the urn. For example, to retrieve the issues of 2 file/document URN’s, use filter[linkedDocumentUrn]=urn%3Aadsk.wipstg%3Adm.lineage%3A7RBfH69GTuuhXnzG5e4oew%2Curn%3Aadsk.wipstg%3Adm.lineage%3A-Rv5HsqqRwiGCM72YhmnOA@1
    filter[dueDate]
    string
    Filter issues by due date, in the following URL-encoded format: YYYY-MM-DD. Separate multiple values with commas. We support the following filtering options:
    • Date range: e.g., 2022-03-02..2022-03-03
    • Specific day: e.g., 2022-03-03
    • Specific start date: e.g., 2022-03-02..
    • Specific end date: e.g., ..2022-03-02

    For more details, see JSON API Filtering.

    filter[createdAt]
    datetime: ISO 8601
    Filter issues that were last created at specified date and time, in one of the following URL-encoded formats: YYYY-MM-DDThh:mm:ss.sz or YYYY-MM-DD. Separate multiple values with commas. We support the following filtering options:
    • Date range: e.g., 2022-03-02..2022-03-03 or 2022-02-28T22:00:00.000Z..2022-03-28T22:00:00.000Z
    • Specific day: e.g., 2022-03-02 or 2022-02-28T22:00:00.000Z
    • Specific start date: e.g., 2022-03-02.. or 2022-02-28T22:00:00.000Z..
    • Specific end date: e.g., ..2022-03-02 or ..2022-02-28T22:00:00.000Z

    For more details, see JSON API Filtering.

    filter[clientCreatedAt]
    datetime: ISO 8601
    Filter issues that were last client created at specified date and time, in one of the following URL-encoded formats: YYYY-MM-DDThh:mm:ss.sz or YYYY-MM-DD. Separate multiple values with commas. We support the following filtering options:
    • Date range: e.g., 2022-03-02..2022-03-03 or 2022-02-28T22:00:00.000Z..2022-03-28T22:00:00.000Z
    • Specific day: e.g., 2022-03-02 or 2022-02-28T22:00:00.000Z
    • Specific start date: e.g., 2022-03-02.. or 2022-02-28T22:00:00.000Z..
    • Specific end date: e.g., ..2022-03-02 or ..2022-02-28T22:00:00.000Z

    For more details, see JSON API Filtering.

    filter[createdBy]
    array: string
    Filter issues by the unique identifier of the user who created the issue. Separate multiple values with commas
    filter[openedAt]
    datetime: ISO 8601
    Filter issues that were last opened at specified date and time, in one of the following URL-encoded formats: YYYY-MM-DDThh:mm:ss.sz or YYYY-MM-DD. Separate multiple values with commas. We support the following filtering options:
    • Date range: e.g., 2022-03-02..2022-03-03 or 2022-02-28T22:00:00.000Z..2022-03-28T22:00:00.000Z
    • Specific day: e.g., 2022-03-02 or 2022-02-28T22:00:00.000Z
    • Specific start date: e.g., 2022-03-02.. or 2022-02-28T22:00:00.000Z..
    • Specific end date: e.g., ..2022-03-02 or ..2022-02-28T22:00:00.000Z

    For more details, see JSON API Filtering.

    filter[openedBy]
    array: string
    Filter issues by the unique identifier of the user who opened the issue. Separate multiple values with commas
    filter[updatedAt]
    datetime: ISO 8601
    Filter issues that were last updated at specified date and time, in one of the following URL-encoded formats: YYYY-MM-DDThh:mm:ss.sz or YYYY-MM-DD. Separate multiple values with commas. We support the following filtering options:
    • Date range: e.g., 2022-03-02..2022-03-03 or 2022-02-28T22:00:00.000Z..2022-03-28T22:00:00.000Z
    • Specific day: e.g., 2022-03-02 or 2022-02-28T22:00:00.000Z
    • Specific start date: e.g., 2022-03-02.. or 2022-02-28T22:00:00.000Z..
    • Specific end date: e.g., ..2022-03-02 or ..2022-02-28T22:00:00.000Z

    For more details, see JSON API Filtering.

    filter[clientUpdatedAt]
    datetime: ISO 8601
    Filter issues that were last client updated at specified date and time, in one of the following URL-encoded formats: YYYY-MM-DDThh:mm:ss.sz or YYYY-MM-DD. Separate multiple values with commas. We support the following filtering options:
    • Date range: e.g., 2022-03-02..2022-03-03 or 2022-02-28T22:00:00.000Z..2022-03-28T22:00:00.000Z
    • Specific day: e.g., 2022-03-02 or 2022-02-28T22:00:00.000Z
    • Specific start date: e.g., 2022-03-02.. or 2022-02-28T22:00:00.000Z..
    • Specific end date: e.g., ..2022-03-02 or ..2022-02-28T22:00:00.000Z

    For more details, see JSON API Filtering.

    filter[updatedBy]
    array: string
    Filter issues by the unique identifier of the user who updated the issue. Separate multiple values with commas
    filter[assignedTo]
    array: string
    Filter issues by the unique identifier of the current assignee of this issue. Separate multiple values with commas
    filter[rootCauseId]
    array: string: uuid
    Filter issues by the unique identifier of the type of root cause for the issue. Separate multiple values with commas
    filter[locationId]
    array: string: uuid
    Filter issues by the unique LBS (Location Breakdown Structure) identifier that relates to the issue. Separate multiple values with commas
    filter[subLocationId]
    array: string: uuid
    Filter issues by the unique LBS (Location Breakdown Structure) identifier that relates to the issue and retreives also all issues with sub locations. Separate multiple values with commas
    filter[closedBy]
    array: string
    Filter issues by the unique identifier of the user who closed the issue. Separate multiple values with commas
    filter[closedAt]
    datetime: ISO 8601
    Filter issues that were last closed at specified date and time, in one of the following URL-encoded formats: YYYY-MM-DDThh:mm:ss.sz or YYYY-MM-DD. Separate multiple values with commas. We support the following filtering options:
    • Date range: e.g., 2022-03-02..2022-03-03 or 2022-02-28T22:00:00.000Z..2022-03-28T22:00:00.000Z
    • Specific day: e.g., 2022-03-02 or 2022-02-28T22:00:00.000Z
    • Specific start date: e.g., 2022-03-02.. or 2022-02-28T22:00:00.000Z..
    • Specific end date: e.g., ..2022-03-02 or ..2022-02-28T22:00:00.000Z

    For more details, see JSON API Filtering.

    filter[search]
    string
    Filter issues using ‘search’ criteia. this will filter both title and issues display Id. For example, use filter[search]=300
    filter[displayId]
    int
    Filter issues by the chronological user-friendly identifier. Separate multiple values with commas
    filter[assignedToType]
    string
    Filter issues by the type of the current assignee of this issue. Separate multiple values with commas
    filter[ownerId]
    string
    Filter issues by the user who owns this issue. Separate multiple values with commas
    filter[customAttributes]
    array: string
    Filter issues by the custom attributes. Each custom attribute filter should be defined by it’s uuid. For example, filter[customAttributes][f227d940-ae9b-4722-9297-389f4411f010]=1,2,3. Separate multiple values with commas.
    limit
    int
    Return specified number of issues. Acceptable values are 1-100. Default value is 100
    offset
    int
    Return issues starting from the specified offset number. Default value is 0
    sort
    array: string
    Sort issues by specified fields. Separate multiple values with commas. To sort in descending order add a - before the sort criteria. For example, sortBy=status,-displayId,-dueDate,customAttributes[5c07cbe2-256a-48f1-b35b-2e5e00914104]
    fields
    array: string
    Return only specific fields in issue object. Separate multiple values with commas. Fields which will be returned in any case: id, title, status, issueTypeId, ownerId

    Response

    HTTP Status Code Summary

    200
    OK
    Returns all issues in combination with pagination details
    400
    Bad Request
    The request could not be understood by the server due to malformed syntax or missing request headers. The client SHOULD NOT repeat the request without modifications. The response body may give an indication of what is wrong with the request
    401
    Unauthorized
    The supplied Authorization header was not valid. Verify Authentication and try again
    403
    Forbidden
    The request was successfully validated but permission is not granted
    404
    Not Found
    The specified resource was not found

    Response

    Body Structure (200)

    Expand all
    pagination
    object
    The pagination object defining the limit, offset, total number of issues, next and previous URL
    limit
    int
    The maximum number of issues to be returned in each page
    offset
    int
    The offset defining the start position from where the issues are returned
    totalResults
    int
    The total number of issues including the ones of the current page
    results
    array: object
    The list of issues in the current page
    id
    string: UUID
    The unique identifier of the issue.
    containerId
    string: UUID
    The unique identifier of the container issue is part of
    displayId
    int
    The chronological user-friendly identifier of the issue
    title
    string
    The title of the issue.

    Max length: 4200

    description
    string
    The description and purpose of the issue.

    Max length: 10000

    snapshotUrn
    string
    Not relevant
    snapshotWipUrn
    string
    Not relevant
    issueTypeId
    string: UUID
    The unique identifier of the type of the issue.
    issueSubtypeId
    string: UUID
    The unique identifier of the subtype of the issue.
    status
    enum:string
    The unique identifier of the current status of the issue Possible values: draft, open, work_completed, ready_to_inspect, in_dispute, not_approved, answered, void, closed
    assignedTo
    string
    The unique Autodesk ID of the User/Company/Role of the current assignee for this issue. Note that if you select an assignee ID, you also need to select a type (assignedToType).
    assignedToType
    enum:string
    The type of the current assignee of this issue. Possible values: user, company, role, null.
    dueDate
    string
    The due date of the issue, in ISO8601 format.
    locationId
    string: UUID
    The unique LBS (Location Breakdown Structure) identifier that relates to the issue.
    locationDetails
    string
    The location as plain text that relates to the issue.

    Max length: 8300

    linkedDocuments
    array: object
    The list of files/documents related to this issue with specific details depending on the type of relationship. Currently linkedDocuments can contain only one item at maximum.
    type
    enum:string
    The type of the relationship Possible values: TwoDVectorPushpin, TwoDRasterPushpin
    urn
    string
    The URN of the file/document that a pushpin was placed on for this issue
    createdBy
    string
    The unique identifier of the user who created the pushpin
    createdAt
    datetime: ISO 8601
    The date and time the pushpin was created, in ISO8601 format
    createdAtVersion
    int
    The URN version of the file/document when the issue was created
    closedBy
    string
    The unique identifier of the user who closed the pushpin
    closedAt
    datetime: ISO 8601
    The date and time the pushpin was closed, in ISO8601 format
    closedAtVersion
    int
    The version URN of the file/document when the issue was closed
    details
    object
    The information about the individual viewable, the pushpin position in the viewable, the ID of the element the pushpin is associated with and the viewer state at creation time
    viewable
    object
    The individual viewable (sheet / 3D view) a pushpin was placed on. Applicable only if URN points to a file (as opposed to a document)
    id
    string
    The unique identifier of the viewable (This field has been depreciated, use guid instead)
    name
    string
    The name of the viewable

    Max length: 1000

    is3D
    boolean
    The flag indicates if it’s a 2D or 3D viewable
    guid
    string
    The unique identifier of the viewable (UUID)
    viewableId
    string
    The identifier of the viewable (String)
    position
    object
    The position of the pushpin in the viewable
    x
    number
    The x-value of the position in the viewable
    y
    number
    The y-value of the position in the viewable
    z
    number
    The z-value of the position in the viewable. For a 2D view this value is not set
    objectId
    int
    The unique identifier of the element the pushpin is associated with in the viewable
    externalId
    string
    An external identifier of the element the pushpin is associated with in the viewable
    viewerState
    object
    The viewer state at the time the pushpin was created max length of 2,500,000 charecters. You can get the viewer state object by calling the ViewerState.getState() API. To restore the viewer instance use ViewerState.restoreState(). See Viewer API documentation here https://developer.autodesk.com/en/docs/viewer/v2/reference/javascript/viewerstate/
    links
    array: object
    A collection of links to checklists. For example, a list of resource URN’s in the Checklist service that this issue is related to.

    To filter by links use the filter[qualityUrns].

    Hint, currently links can contain only one item at maximum.

    type
    enum:string
    The type of the entity link Will always be: checklist
    data
    object
    A custom object describing the entity link data
    *
    string
    ownerId
    string
    The unique identifier of the user who owns this issue. Used in case this issue was created on-behalf of another person

    Max length: 100

    rootCauseId
    string: UUID
    The unique identifier of the type of root cause for the issue.
    officialResponse
    object
    The official response of the user for the issue
    response
    string
    The suggested response of the user

    Max length: 1900

    respondedAt
    datetime: ISO 8601
    The date and time the issue was responded, in ISO8601 format
    respondedBy
    string
    The unique identifier of the user that suggested a response for the issue
    issueTemplateId
    string: UUID
    Not relevant
    permittedStatuses
    array: string
    A list of statuses accessible to the current user, this is based on the current status of the issue and the user permissions.

    Possible Values: draft, open, work_completed, ready_to_inspect, in_dispute, not_approved, answered, void, closed.

    permittedAttributes
    array: string
    A list of attributes the current user can manipulate in the current context. issueTypeId, linkedDocument, links, ownerId, officialResponse, rootCauseId, snapshotUrn are not applicable.

    Possible Values: title, description, issueTypeId, issueSubtypeId, status, assignedTo, assignedToType, dueDate, locationId, locationDetails, linkedDocuments, links, ownerId, rootCauseId, officialResponse, customAttributes, clientUpdatedAt, snapshotUrn.

    permittedActions
    object
    The list of actions permitted for the user for this issue in its current state.

    Possible Values: assign_all, assign_same_company, assign_creator_or_owner, clear_assignee, add_comment, add_attachment, remove_attachment.

    The following values are not relevant: add_attachment, remove_attachment.

    commentCount
    int
    The number of comments in this issue.
    attachmentCount
    int
    The number of attachments added to this issue
    openedBy
    string
    The unique identifier of the user who opened the issue.
    openedAt
    datetime: ISO 8601
    The date and time the issue was opened, in ISO8601 format.
    closedBy
    string
    The unique identifier of the user who closed the issue.
    closedAt
    datetime: ISO 8601
    The date and time the issue was closed, in ISO8601 format.
    createdBy
    string
    The unique identifier of the user who created the issue.
    createdAt
    datetime: ISO 8601
    The date and time the issue was created, in ISO8601 format.
    updatedBy
    string
    The unique identifier of the user who updated the issue.
    updatedAt
    datetime: ISO 8601
    The date and time the issue was updated, in ISO8601 format.
    clientCreatedAt
    datetime: ISO 8601
    Not relevant
    clientUpdatedAt
    datetime: ISO 8601
    Not relevant
    customAttributes
    array: object
    A list of custom attributes of the specific issue.
    attributeDefinitionId
    string: UUID
    value
    object
    Custom attributes value. in case of a list option, the id of the selected option, otherwise can be string/text/date/boolean
    type
    enum:string
    Type of the attribute: value should of the corresponding format Possible values: numeric, paragraph, list, text
    title
    object
    Free text description of the attribute
    *

    Example

    Returns all issues in combination with pagination details

    Request

    curl -v 'https://developer.api.autodesk.com/issues/v2/containers/a5f49f04-59bb-477c-97e6-6833cb50bdac/issues?filter[id]=a5f49f04-59bb-477c-97e6-6833cb50bdac,a5f49f04-59bb-477c-97e6-6833cb50b123&filter[qualityUrns]=urn:some.checklist.urn.3,urn:some.checklist.urn.1&filter[issueTypeId]=a5f49f04-59bb-477c-97e6-6833cb50bdac,a5f49f04-59bb-477c-97e6-6833cb50b123&filter[issueSubtypeId]=a5f49f04-59bb-477c-97e6-6833cb50bdac,a5f49f04-59bb-477c-97e6-6833cb50b123&filter[status]=a5f49f04-59bb-477c-97e6-6833cb50bdac,a5f49f04-59bb-477c-97e6-6833cb50b123' \
      -H 'Authorization: Bearer AuIPTf4KYLTYGVnOHQ0cuolwCW2a'
    

    Response

    {
      "pagination": {
        "limit": "",
        "offset": "",
        "totalResults": ""
      },
      "results": [
        {
          "id": "3570f222-6c54-4b01-90e6-e701749f0222",
          "containerId": "2220f222-6c54-4b01-90e6-d701748f0222",
          "displayId": 7,
          "title": "Door missing a screw",
          "description": "The door is missing a screw, please fix this",
          "snapshotUrn": "",
          "snapshotWipUrn": "",
          "issueTypeId": "8770f222-6c54-4e01-93e6-e701749f0222",
          "issueSubtypeId": "1370f222-6c54-3a01-93e6-e701749f0222",
          "status": "open",
          "assignedTo": "A3RGM375QTZ7",
          "assignedToType": "user",
          "dueDate": "2018-07-25",
          "locationId": "35de6f24-39f5-4808-ba5f-6cbbe2a858e1",
          "locationDetails": "issue location details",
          "linkedDocuments": [
            {
              "type": "TwoDVectorPushpin",
              "urn": "urn:adsk.wipprod:dm.lineage:0C9edNQuT2SrfoyKQ1Gv_Q",
              "createdBy": "",
              "createdAt": "",
              "createdAtVersion": 1,
              "closedBy": "",
              "closedAt": "",
              "closedAtVersion": 1,
              "details": {
                "viewable": {
                  "id": "",
                  "name": "",
                  "is3D": "",
                  "guid": "",
                  "viewableId": ""
                },
                "position": {
                  "x": "",
                  "y": "",
                  "z": ""
                },
                "objectId": "",
                "externalId": "",
                "viewerState": {}
              }
            }
          ],
          "links": [
            {
              "type": "checklist",
              "data": {
                "urn1": "urn:adsk.checklists.cs.instance:f0aa1265-ecf1-4fe6-b192-dcebf34be020/505",
                "urn2": "urn:adsk.checklists.cs.instance:f0aa1265-ecf1-4fe6-b192-dcebf34be021/506"
              }
            }
          ],
          "ownerId": "owner Id",
          "rootCauseId": "2370f222-6c54-3a01-93e6-f701772f0222",
          "officialResponse": {
            "response": "",
            "respondedAt": "",
            "respondedBy": ""
          },
          "issueTemplateId": "",
          "permittedStatuses": [
            "open"
          ],
          "permittedAttributes": [
            "title"
          ],
          "permittedActions": {},
          "commentCount": 3,
          "attachmentCount": "",
          "openedBy": "A3RGM375QTZ7",
          "openedAt": "2018-07-22T15:05:58.033Z",
          "closedBy": "A3RGM375QTZ7",
          "closedAt": "2018-07-22T15:05:58.033Z",
          "createdBy": "A3RGM375QTZ7",
          "createdAt": "2018-07-22T15:05:58.033Z",
          "updatedBy": "A3RGM375QTZ7",
          "updatedAt": "2018-07-22T15:05:58.033Z",
          "clientCreatedAt": "2000-02-04T09:44:58.867Z",
          "clientUpdatedAt": "2000-02-04T09:44:58.867Z",
          "customAttributes": [
            {
              "attributeDefinitionId": "2220f222-6c54-4b01-90e6-d701748f0888",
              "value": "fast",
              "type": "numeric",
              "title": "Secondary Title"
            }
          ]
        }
      ]
    }
    
    Show More